 
 
#property library
#include <WinUser32.mqh>
#include <stdlib.mqh>
//---
//----------------------------------------------------------------------------------------+
//|                                                                                       |
//|                                                                           |
//|---------------------------------------------------------------------------------------+
void NeuroNet_SOM(string NameWW, double in[], double& ww[][], double& Out_Net[], int Nk, 
                                                   bool Tranning=false, double myu=0.0001)
{
   int M=ArraySize(in);  //   x
   double S;
   int i,j,Vj;
  
//----------------------------------------------------------------+
//|                                        |
//----------------------------------------------------------------+
   static double Sum_old=0;
   double Sum_in=0;
   //      
   for(int p=0; p<=M-1; p++) 
   { Sum_in+=in[p]; }
   //---
   if(Sum_in==Sum_old) 
   { 
     //Comment("    ");
      return;
   }
   else  Sum_old=Sum_in;
   //---

//+----------------------------------------------------------------------------------------+
//|                                                                            |
//+----------------------------------------------------------------------------------------+
   //---
   ArrayResize(Out_Net,Nk);
   //---
   S=0;
   for( j=0; j<=Nk-1; j++) //  
      {
         S=0; //  
         for( i=0; i<=M-1; i++) 
         { 
              S+=in[i]*ww[i,j];
         }
         //  
         Out_Net[j]=th(S);
      }
   //---
   //  
      Vj=ArrayMaximum(Out_Net);
   //---
   for( j=0; j<=Nk-1; j++) //  
      {
         if ( j!=Vj) Out_Net[j]=-1;
      }
   //---
   if( Tranning )
   {
      //---
      //    Vj
      for( i=0; i<=M-1; i++) 
      { 
         ww[i,Vj]=ww[i,Vj]+myu*(in[i]-ww[i,Vj]);
      }
      //---
      Write_Net_SOM(NameWW,ww);
   }
   //---
   err("NeuroNet_SOM");
   //------------------------------------------------------------------------------------+
   return;
}
//---------------------------------------------------------------------------------+
//|                                                   |
//|                                                                                |
//|--------------------------------------------------------------------------------+
void NeuroNet_UL(string NameWW, double in[], double& ww[][][2], double& Out_Net[], 
                  int Nk,  bool Tranning=false, double myu=0.0001)
{
   int M=ArraySize(in);  //   x
   double S;
   int i,j,Vj;
   double out_Koh[];
//----------------------------------------------------------------+
//|         |
//----------------------------------------------------------------+
   static double Sum_old=0;
   double Sum_in=0;
   //      
   for(int p=0; p<=M-1; p++) 
   { Sum_in+=in[p]; }
   //---
   if(Sum_in==Sum_old) 
   { 
     //Comment("    ");
      return;
   }
   else  Sum_old=Sum_in;
   //---
//+---------------------------------------------------------------+
//|                                                   |
//+---------------------------------------------------------------+
   //---
   ArrayResize(out_Koh,Nk);
   //---
   for( j=0; j<=Nk-1; j++) //  
      {
         S=0; //  
         for( i=0; i<=M-1; i++) 
         { 
              S+=in[i]*ww[i,j,0];
         }
         //  
         out_Koh[j]=th(S);
      }
   //---
   //  
      Vj=ArrayMaximum(out_Koh);
   //---
   for( j=0; j<=Nk-1; j++) //  
      {
         if ( j!=Vj) out_Koh[j]=-1;
      }
   //---
//+---------------------------------------------------------------+
//|                                                 |
//+---------------------------------------------------------------+
   //---
   ArrayResize(Out_Net,M);
   //---
   for( j=0; j<=M-1; j++) //   
      {
         S=0; //  
         for( i=0; i<=Nk-1; i++) //   
         { 
              S+=out_Koh[i]*ww[i,j,1];
         }
         //  
         Out_Net[j]=th(S);
      }
   //---
//+---------------------------------------------------------------+
//|                                                  |
//+---------------------------------------------------------------+
   if( Tranning )
   {
      //---
      //    Vj  
      for( i=0; i<=M-1; i++) 
      { 
         ww[i,Vj,0]=ww[i,Vj,0]+myu*(in[i]-ww[i,Vj,0]);
      }
      //---
      //    
      for (j=0; j<=M-1; j++)
      {
         for( i=0; i<=Nk-1; i++) //   
         { 
            ww[i,j,1]=ww[i,j,1]+myu*(in[j]-ww[i,j,1])*out_Koh[i];
         }
      }
      //---
      Write_Net_UL(NameWW,ww);
   }
   //---
   err("NeuroNet_UL");
   //----------------------------------------------------------------+
   return;
}
//+------------------------------------------------------------------+
//|                         |
//+------------------------------------------------------------------+
int InitNet_WW_UL(string NameWW, double& ww[][][])
{
   int rez;
   int M=ArrayRange(ww,0);
   int N=ArrayRange(ww,1);
   int L=ArrayRange(ww,2);
   //---
   MathSrand(CurTime());
   double rand;
   //---
   int handle;
   handle=FileOpen(NameWW, FILE_BIN|FILE_READ);
   //---
   if(handle>0)
     {
      FileReadArray(handle, ww, 0,M*N*L);
      FileClose(handle);
      Print(" ",NameWW,"   !");
      rez=1;
     }
   //---
   if(handle<1)
    {
     Print(" ",NameWW,"  ,    ");
     //---
     for( int l=0; l<=L-1; l++)
     {
         for(int j=0;j<=N-1;j++)
         {
            for(int i=0; i<=M-1; i++) 
            { 
               rand=MathRand();
               ww[i,j,l]=(0.5-rand/32767.0); 
            }
         }
      }
     rez=-1;
    }
   //---
   err("InitNet_WW_UL");
   return(rez);
}
//+------------------------------------------------------------------+
//|                                       |
//+------------------------------------------------------------------+
int InitNet_WW_SOM(string NameWW, double& ww[][])
{
   int rez;
   int M=ArrayRange(ww,0);
   int N=ArrayRange(ww,1);
   //---
   MathSrand(CurTime());
   double rand;
   //---
   int handle;
   handle=FileOpen(NameWW, FILE_BIN|FILE_READ);
   //---
   if(handle>0)
     {
      FileReadArray(handle, ww, 0,M*N);
      FileClose(handle);
      Print(" ",NameWW,"   !");
      rez=1;
     }
   //---
   if(handle<1)
    {
     Print(" ",NameWW,"  ,    ");
     //---
         for(int j=0;j<=N-1;j++)
         {
            for(int i=0; i<=M-1; i++) 
            { 
               rand=MathRand();
               ww[i,j]=(0.5-rand/32767.0); 
            }
         }
     rez=-1;
    }
   //---
   err("InitNet_WW_SOM");
   return(rez);
}
//+------------------------------------------------------------------+
//|                    WW[][][]           |
//+------------------------------------------------------------------+
void Write_Net_UL(string Name, double ww[][][])
{
   int M=ArrayRange(ww,0);
   int N=ArrayRange(ww,1);
   int L=ArrayRange(ww,2);

   int handle=FileOpen(Name, FILE_BIN|FILE_WRITE);
   //---
   if(handle>0)
      {
         FileWriteArray(handle, ww, 0, M*N*L);
         FileFlush(handle);
         FileClose(handle);
      }
   //---
   err("Write_Net_UL");
   return;
}
//+------------------------------------------------------------------+
//|                    WW[][]             |
//+------------------------------------------------------------------+
void Write_Net_SOM(string Name, double ww[][])
{
   int M=ArrayRange(ww,0);
   int N=ArrayRange(ww,1);

   int handle=FileOpen(Name, FILE_BIN|FILE_WRITE);
   //---
   if(handle>0)
      {
         FileWriteArray(handle, ww, 0, M*N);
         FileFlush(handle);
         FileClose(handle);
      }
   //---
   err("Write_Net_SOM");
   return;
}
//---
//+------------------------------------------------------------------+ 
//|                                  | 
//| :                                                         | 
//|                                       | 
//| :                                                       | 
//|   source      -                                   | 
//|   dest        -                                    | 
//|   delimeter   -                                       | 
//+------------------------------------------------------------------+ 
int StrSplit(string source, string& dest[], string delimeter = ";") 
{ 
   int cnt = 0; 
   int last_pos = 0; 
   int pos = StringFind(source, delimeter, last_pos); 
    
   while (pos != -1) { 
      ArrayResize(dest, cnt + 1); 
      dest[cnt] = StringSubstr(source, last_pos, pos - last_pos); 
      cnt++; 
      last_pos = pos + 1; 
      pos = StringFind(source, delimeter, last_pos); 
   } 
   if (last_pos != 0 && last_pos < StringLen(source)){    
      ArrayResize(dest, cnt + 1); 
      dest[cnt] = StringSubstr(source, last_pos, StringLen(source) - last_pos); 
      cnt++; 
   } 
   return (cnt); 
}
//====================================================================+

//+------------------------------------------------------------------+
//|       +1 -1        |
//+------------------------------------------------------------------+
void InNormalize(double& aa[])
{
   int I=ArraySize(aa);
   double rmax=aa[ArrayMaximum(aa)];
   double rmin=aa[ArrayMinimum(aa)];
   double range=(rmax-rmin);
   if( range==0 ) { Print ("InNormalize:  range=0"); }
   for(int i=0;i<=I-1;i++)
   {
     aa[i]=2*(aa[i]-rmin)/range-1;
   }
   err("InNormalize");
   return;
}
//+------------------------------------------------------------------+
//|                                                    |
//+------------------------------------------------------------------+
double F_Target(double aa[], double bb[], int N)
{
   double sum;
   sum=0;
   for(int i=0; i<=N-1; i++)
   {
      sum+=MathPow(aa[i]-bb[i],2);
   }
   return(sum/2);
}
//+------------------------------------------------------------------+
//|                                                  |
//+------------------------------------------------------------------+
double arcth(double x)
{
  return(MathArctan(x));
}
//+------------------------------------------------------------------+
//|                                            |
//+------------------------------------------------------------------+
double th(double x)
{
   double x_=MathExp(x);
   double _x=MathExp(-x);
   
   double a=(x_+_x);
   double b=(x_-_x);
   if( a==0) a=0.0000000001;
   return(b/a);
}
//+------------------------------------------------------------------+
//|                                                   |
//+------------------------------------------------------------------+
void err(string name)
{
   int err=GetLastError();
   if(err!=0)
    {
     Print(name, " error(",err,"): ",ErrorDescription(err));
    }
     return;
}
//--------------------------------------------------------------------+
//+------------------------------------------------------------------+
//|                                                 |
//+------------------------------------------------------------------+
void bkp()
{
      //     
      //----
            keybd_event(19,0,0,0); //   VK_PAUSE=19  0x13
            keybd_event(19,0,KEYEVENTF_KEYUP,0); //  
      //---
      return;
}

